Topcoder SRM 687 div2

通过数:2

250:

#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>

using namespace std;

class Quorum {
public:
    int count(vector <int>, int);
};

int Quorum::count(vector <int> arr, int k) {
    sort(arr.begin(), arr.end());
    int res = 0;
    for(int i = 0 ; i < min(k, (int)arr.size()) ; i++)
        res += arr[i];
    return res;
}

<%:testing-code%>
//Powered by [KawigiEdit] 2.0!

500:

加一个vector用来回溯就好

#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>

using namespace std;

class Quacking {
public:
    int quack(string);
};
string str = "quack";
int Quacking::quack(string s) {
    int n = s.size();
    int res = 0;
    int vis[5000];
    for(int i = 0 ; i < n ; i++) {
//        printf("i = %d\n", i);
        if(vis[i] == 1) continue;
        else if(s[i] != ‘q‘) return -1;
        int num = 0;
        vector<int>rev;
        for(int j = i ; j < n ; j++) {
            if(vis[j] == 1) continue;
            if(s[j] == str[num]) {
                num++, vis[j] = 1, rev.push_back(j);//, printf("%d ", j);
            }
            if(num == 5) {
                rev.clear();
                num = 0;
            }
        }
//        puts("");
        for(int j = 0 ; j < (int)rev.size() ; j++) vis[rev[j]] = 0;
        res++;
    }
    for(int i = 0 ; i < n ; i++) if(vis[i] == 0) return -1;
    return res;
}

<%:testing-code%>
//Powered by [KawigiEdit] 2.0!

1000:

打死想不到是概率DP

转换后发现原式表示的是f(p,k)表示前k-1天均未完成,第k天完成的概率

那么,每天完成的概率就是1/p

Dp[i][j]表示到达(i,j)状态时,第一个任务消耗时间严格小于第一个任务的概率

初始化dp[i][0] = 0, dp[0][i!=0] = 1

#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>

using namespace std;

class Queueing {
public:
    double probFirst(int, int, int, int);
};
const int MAXN = 1000 + 5;
double dp[MAXN][MAXN];
double Queueing::probFirst(int len1, int len2, int p1, int p2) {
    double q1 = 1.0 / (1.0 * p1);
    double q2 = 1.0 / (1.0 * p2);
    for(int i = 0 ; i <= len1 ; i++) {
        for(int j = 0 ; j <= len2 ; j++) {
            if(j == 0) dp[i][j] = 0;
            else if(i == 0) dp[i][j] = 1;
            else {
                double temp1 = (q1) * (q2) * dp[i - 1][j - 1];
                double temp2 = (1 - q1) * q2 * dp[i][j - 1];
                double temp3 = (q1) * (1 - q2) * dp[i - 1][j];
                dp[i][j] = (temp1 + temp2 + temp3) / (1.0 - (1 - q1) * (1 - q2));
            }
        }
    }
    return dp[len1][len2];
}

<%:testing-code%>
//Powered by [KawigiEdit] 2.0!
时间: 2024-11-06 09:37:08

Topcoder SRM 687 div2的相关文章

topcoder SRM 618 DIV2 WritingWords

只需要对word遍历一遍即可 int write(string word) { int cnt = 0; for(int i = 0 ; i < word.length(); ++ i){ cnt+=word[i]-'A'+1; } return cnt; } topcoder SRM 618 DIV2 WritingWords,布布扣,bubuko.com

topcoder SRM 618 DIV2 MovingRooksDiv2

一开始Y1,Y2两个参数看不懂,再看一遍题目后才知道,vector<int>索引代表是行数,值代表的是列 此题数据量不大,直接深度搜索即可 注意这里深度搜索的访问标识不是以前的索引和元素,而是一个交换元素后的整个状态vector<int>,这样可以避免重复元素的搜索 set<vector<int> > visit; bool flag; void dfs(vector<int>& src, vector<int>& d

topcoder SRM 618 DIV2 LongWordsDiv2

此题给出的条件是: (1)word的每个字母都是大写字母(此条件可以忽略,题目给的输入都是大写字母) (2) 相等字符不能连续,即不能出现AABC的连续相同的情况 (3)word中不存在字母组成xyxy的形式,即不存在第一个字符和第3个字符相等同时第2个字符和第4个字符相等的情况 对于第(2)种情况,只需要考虑word[i]!=word[i-1]即可 对于第(3)种情况,用一个4重循环遍历每种可能的情况,然后第一个字符和第3个字符相等同时第2个字符和第4个字符相等,则输出“DisLikes”即可

TOPCODER SRM 686 div2 1000

// TOPCODER SRM 686 div2 1000 Problem Statement 给出一个至多长 100 的字符串,仅包含 ( 和 ),问其中有多少个不重复的,合法的括号子序列. 子序列可以不连续:合法即括号序列的合法:答案模 1,000,000,007. Examples "(())(" Returns: 2 Correct non-empty bracket subsequences are "()" and "(())". &

topcoder srm 628 div2 250 500

做了一道题,对了,但是还是掉分了. 第二道题也做了,但是没有交上,不知道对错. 后来交上以后发现少判断了一个条件,改过之后就对了. 第一道题爆搜的,有点麻烦了,其实几行代码就行. 250贴代码: 1 #include <iostream> 2 #include <cstring> 3 #include <queue> 4 #include <cmath> 5 #include <cstdio> 6 #include <algorithm&g

topcoder SRM 619 DIV2 GoodCompanyDivTwo

注意题目给的最后一句话,如果部门任何employee都做不同类型的工作,则这个部门是一个diverse,题目是计算department的diverse数 读起来感觉有点别扭,英语没学好的原因 int countGood(vector <int> superior, vector <int> workType) { int res = 0; for(int i = 0 ; i < superior.size(); ++ i){ set<int> department

Topcoder SRM 619 DIv2 500 --又是耻辱的一题

这题明明是一个简单的类似约瑟夫环的问题,但是由于细节问题迟迟不能得到正确结果,结果比赛完几分钟才改对..耻辱. 代码: #include <iostream> #include <cstdio> #include <cstring> #include <cmath> #include <algorithm> #define ll long long using namespace std; #define NN 370000 class Choo

Topcoder SRM 648 Div2 1000

Problem 给一个长度为N的字符串S,S只含有'A'.'B'.'C'三种元素.给定一个K,要求返回字符串S,使得S中恰好有K对pair(i,j)满足 0=<i<j<N,且 S[i]<S[j].若不存在,则返回空串. Limits Time Limit(ms): 2000 Memory Limit(MB): 256 N: [3, 30] K: [0, N*(N-1)/2 ] Solution 设S中含有n1个'A',n2个'B',n3个'C',设num=n1*n2+n1*n3+n

topcoder SRM 522 DIV2 BoxesDiv2

注意题目这句话,Once you have each type of candies in a box, you want to pack those boxes into larger boxes, until only one box remains. 两个box合并后必须放入更大一个盒子 题目的有点类似huffman的前部分,此题用堆去做,由于priority_queue是用堆实现的,故可以直接使用 每次从堆中选取最小的两个进行合并即可 #include <iostream> #incl